// $Id: parameters.h,v 1.1 2003/11/04 22:32:40 ensc Exp $    --*- c++ -*--

// Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//  
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#ifndef H_VSERVER_DJINNI_SRC_PARAMETERS_H
#define H_VSERVER_DJINNI_SRC_PARAMETERS_H

#include <stdlib.h>
#include <stdbool.h>

struct DjinniProcess;

struct Parameters
{
    size_t	argc;
    char **	argv;
    size_t *	lens;

    size_t	idx_;

    char const *	vserver_vdir;
    char const *	vserver_name;
};

bool	Parameters_init(struct Parameters *);
void	Parameters_delete(struct Parameters *);

bool	Parameters_setArgCount(struct Parameters *, size_t cnt);
char *	Parameters_allocParam(struct Parameters *self, size_t len);
bool	Parameters_normalize(struct Parameters *);

bool	Parameters_evaluate(struct Parameters *,
			    struct DjinniProcess const *proc,
			    unsigned int *code, char const **reason);

#endif	//  H_VSERVER_DJINNI_SRC_PARAMETERS_H
