// $Id: syntaxinfo.h,v 1.1 2003/11/04 22:32:40 ensc Exp $    --*- c -*--

// Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//  
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#ifndef H_VSERVER_DJINNIE_SRC_SYNTAXINFO_H
#define H_VSERVER_DJINNIE_SRC_SYNTAXINFO_H

#include <stdbool.h>
#include <stdlib.h>

typedef enum { synVSERVER, synINT, synUINT, synPATH,
	       synSET, synSTRING } SyntaxInfoType;
	       
struct SyntaxInfo
{
    SyntaxInfoType		type;
    union {
	struct {
	    unsigned int	min;
	    unsigned int	max;
	}			u;

	struct {
	    int			min;
	    int			max;
	}			i;

	struct {
	    char **		v;
	    size_t		l;
	}			set;
    }				info;
};

bool	SyntaxInfo_init(struct SyntaxInfo *info, char const **ptr);
void	SyntaxInfo_destroy(struct SyntaxInfo *info);

#endif	//  H_VSERVER_DJINNIE_SRC_SYNTAXINFO_H
