// $Id: wish.h,v 1.1 2003/11/04 22:32:40 ensc Exp $    --*- c++ -*--

// Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//  
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#ifndef H_UTIL_VSERVER_SRC_WISH_H
#define H_UTIL_VSERVER_SRC_WISH_H

#include "credentials.h"
#include <stdbool.h>

struct Parameters;

  // None of these methods must call exit() on I/O-errors


struct Wish
{
    struct Credentials		creds_;
    bool			has_creds_;
    int				fd_;

    pid_t			pid_;
    char			confirm_data_[32];
};

struct WishResult
{
    enum { resOK, resFAIL }	res;

    size_t			len;
    int				code;
    char *			data;
};

bool	Wish_init(struct Wish *, int fd, struct Credentials const *creds);
void	Wish_delete(struct Wish *);
bool	Wish_recv(struct Wish *, struct Parameters *);
struct Credentials const *	Wish_getCredentials(struct Wish const *);

struct WishResult		Wish_send(struct Wish *, size_t argc,
					  char const * const argv[]);

bool	Wish_sendResult(int fd, unsigned int code, char const *data, size_t len);

#endif	//  H_UTIL_VSERVER_SRC_WISH_H
